//=============================================================================
// HXGenericCarcass
// it's cool to have a generic carcass class for all pawns, but the major
// drawback is, that all nearly all variables copied from the default carcass
// needs to be replicated when the carcass becomes relevant, well i might
// change this later, but i don't like having this in mind before starting
// coding a generic DeusExDecoration class, because the game is full of such
// stuff, on the other hand i don't like to have an own class for each fucking
// carcass and decoration, but a generic class sucks lot of bandwidth
// i fuckin' hate it... :(
//=============================================================================
class HXGenericCarcass extends DeusExCarcass;

// class of carcass we imitate
var class<DeusExCarcass> ImitatedCarcass;
var float SavedCollisionHeight;


// ----------------------------------------------------------------------
// InitFor()
// ----------------------------------------------------------------------

function InitFor(Actor Other)
{
	if (Other == None)
		return;

	// copy values from original carcass type
	if (Other.isA('ScriptedPawn'))
		ImitatedCarcass = class<DeusExCarcass>(ScriptedPawn(Other).CarcassType);
	else if (Other.isA('PlayerPawn'))
		ImitatedCarcass = class<DeusExCarcass>(PlayerPawn(Other).CarcassType);	

	if (ImitatedCarcass != none)
	{
		// copy properties for orginal carcass class
		bAnimalCarcass	= ImitatedCarcass.Default.bAnimalCarcass;
		Mesh						= ImitatedCarcass.Default.Mesh;
		Mesh2						= ImitatedCarcass.Default.Mesh2;
		Mesh3						= ImitatedCarcass.Default.Mesh3;
		Texture					= ImitatedCarcass.Default.Texture;
		MultiSkins[0]		= ImitatedCarcass.Default.MultiSkins[0];
		MultiSkins[1]		= ImitatedCarcass.Default.MultiSkins[1];
		MultiSkins[2]		= ImitatedCarcass.Default.MultiSkins[2];
		MultiSkins[3]		= ImitatedCarcass.Default.MultiSkins[3];
		MultiSkins[4]		= ImitatedCarcass.Default.MultiSkins[4];
		MultiSkins[5]		= ImitatedCarcass.Default.MultiSkins[5];
		MultiSkins[6]		= ImitatedCarcass.Default.MultiSkins[6];
		MultiSkins[7]		= ImitatedCarcass.Default.MultiSkins[7];
		DrawScale				= ImitatedCarcass.Default.DrawScale;
		AmbientGlow			= ImitatedCarcass.Default.AmbientGlow;
		LightType				= ImitatedCarcass.Default.LightType;
		LightBrightness	= ImitatedCarcass.Default.LightBrightness;
		LightHue				= ImitatedCarcass.Default.LightHue;
		LightSaturation	= ImitatedCarcass.Default.LightSaturation;
		LightRadius			= ImitatedCarcass.Default.LightRadius;

		// save CollisionHeight for state Dead.HandleLanding()
		SavedCollisionHeight = ImitatedCarcass.Default.CollisionHeight;

		SetCollisionSize(ImitatedCarcass.Default.CollisionRadius,
										 ImitatedCarcass.Default.CollisionHeight);
	}
	else
		Log("(EE) Failed setting ImitatedCarcass");

	// set as unconscious or add the pawns name to the description
	if (!bAnimalCarcass)
	{
		if (bNotDead)
			itemName = msgNotDead;
		else if (Other.IsA('ScriptedPawn'))
			itemName = itemName $ " (" $ ScriptedPawn(Other).FamiliarName $ ")";
	}

	Mass           = Other.Mass;
	Buoyancy       = Mass * 1.2;
	MaxDamage      = 0.8*Mass;
	if (ScriptedPawn(Other) != None)
		if (ScriptedPawn(Other).bBurnedToDeath)
			CumulativeDamage = MaxDamage-1;

	SetScaleGlow();

	// Will this carcass spawn flies?
	if (bAnimalCarcass)
	{
		itemName = msgAnimalCarcass;
		if (FRand() < 0.2)
			bGenerateFlies = true;
	}
	else if (!Other.IsA('Robot') && !bNotDead)
	{
		if (FRand() < 0.1)
			bGenerateFlies = true;
		bEmitCarcass = true;
	}

	if (Other.AnimSequence == 'DeathFront')
		Mesh = Mesh2;

	// set the instigator and tag information
	if (Other.Instigator != None)
	{
		KillerBindName = Other.Instigator.BindName;
		KillerAlliance = Other.Instigator.Alliance;
	}
	else
	{
		KillerBindName = Other.BindName;
		KillerAlliance = '';
	}

	Tag = Other.Tag;
	Alliance = Pawn(Other).Alliance;
	CarcassName = Other.Name;
}


// ----------------------------------------------------------------------
// Frob()
// ----------------------------------------------------------------------

function Frob(Actor Frobber, Inventory frobWith)
{
	local Inventory item, nextItem, startItem;
	local Pawn P;
	local DeusExWeapon W;
	local bool bFoundSomething;
	local DeusExPlayer player;
	local ammo AmmoType;
	local bool bPickedItemUp;
	local POVCorpse corpse;
	local DeusExPickup invItem;
	local int itemCount;

	//log("DeusExCarcass::Frob()--------------------------------");

	// Can we assume only the *PLAYER* would actually be frobbing carci?
	// i hope so H* ;)
	player = DeusExPlayer(Frobber);

	// No doublefrobbing in multiplayer.
	if (bQueuedDestroy)
		return;

	// use this as a placeholder for already frobbing players
	bQueuedDestroy = true;

	// if we've already been searched, let the player pick us up
	// don't pick up animal carcii
	// HX_NOTE disabled, i don't have a model for corpses yet, and since it is only *realy* needed in 00_Training
	// ignore it
/*
	if (!bAnimalCarcass)
	{
		// DEUS_EX AMSD Since we don't have animations for carrying corpses, and since it has no real use in multiplayer,
		// and since the PutInHand propagation doesn't just work, this is work we don't need to do.
		// Were you to do it, you'd need to check the respawning issue, destroy the POVcorpse it creates and point to the
		// one in inventory (like I did when giving the player starting inventory).
		if ((Inventory == None) && (player != None) && (player.inHand == None) && (Level.NetMode == NM_Standalone))
		{
			if (!bInvincible)
			{
				corpse = Spawn(class'POVCorpse');
				if (corpse != None)
				{
					// destroy the actual carcass and put the fake one
					// in the player's hands
					corpse.carcClassString = String(Class);
					corpse.KillerAlliance = KillerAlliance;
					corpse.KillerBindName = KillerBindName;
					corpse.Alliance = Alliance;
					corpse.bNotDead = bNotDead;
					corpse.bEmitCarcass = bEmitCarcass;
					corpse.CumulativeDamage = CumulativeDamage;
					corpse.MaxDamage = MaxDamage;
					corpse.CorpseItemName = itemName;
					corpse.CarcassName = CarcassName;
					corpse.Frob(player, None);
					corpse.SetBase(player);
					player.PutInHand(corpse);
					bQueuedDestroy=True;
					Destroy();
					return;
				}
			}
		}
	}
*/

	bFoundSomething = False;
	bSearchMsgPrinted = False;
	P = Pawn(Frobber);
	if (P != None)
	{
		// Make sure the "Received Items" display is cleared
      // DEUS_EX AMSD Don't bother displaying in multiplayer.  For propagation
      // reasons it is a lot more of a hassle than it is worth.
		if ( (player != None) && (Level.NetMode == NM_Standalone) )
         DeusExRootWindow(player.rootWindow).hud.receivedItems.RemoveItems();

		if (Inventory != None)
		{

			item = Inventory;
			startItem = item;

			do
			{
//				log("===>DeusExCarcass:item="$item );

				nextItem = item.Inventory;
				

				bPickedItemUp = False;

				if (item.IsA('Ammo'))
				{
					// Only let the player pick up ammo that's already in a weapon
					DeleteInventory(item);
					item.Destroy();
					item = None;
				}
				else if ( (item.IsA('DeusExWeapon')) )
				{
               // Any weapons have their ammo set to a random number of rounds (1-4)
               // unless it's a grenade, in which case we only want to dole out one.
               // DEUS_EX AMSD In multiplayer, give everything away.
               W = DeusExWeapon(item);
               
               // Grenades and LAMs always pickup 1
               if (W.IsA('WeaponNanoVirusGrenade') || 
                  W.IsA('WeaponGasGrenade') || 
                  W.IsA('WeaponEMPGrenade') ||
                  W.IsA('WeaponLAM'))
                  W.PickupAmmoCount = 1;
               else //if (Level.NetMode == NM_Standalone)
                  W.PickupAmmoCount = Rand(4) + 1;
				}
				
				if (item != None)
				{
					bFoundSomething = True;

					if (item.IsA('NanoKey'))
					{
						if (player != None)
						{
							player.PickupNanoKey(NanoKey(item));
							AddReceivedItem(player, item, 1);
							DeleteInventory(item);
							item.Destroy();
							item = None;
						}
						bPickedItemUp = True;
					}
					else if (item.IsA('Credits'))		// I hate special cases (HX_NOTE: me dx code, asshole :p)
					{
						if (player != None)
						{
							AddReceivedItem(player, item, Credits(item).numCredits);
							player.Credits += Credits(item).numCredits;
							P.ClientMessage(Sprintf(Credits(item).msgCreditsAdded, Credits(item).numCredits));
							DeleteInventory(item);
							item.Destroy();
							item = None;
						}
						bPickedItemUp = True;
					}
					else if (item.IsA('DeusExWeapon'))   // I *really* hate special cases
					{
						// Okay, check to see if the player already has this weapon.  If so,
						// then just give the ammo and not the weapon.  Otherwise give
						// the weapon normally. 
						W = DeusExWeapon(player.FindInventoryType(item.Class));

						// If the player already has this item in his inventory, piece of cake,
						// we just give him the ammo.  However, if the Weapon is *not* in the 
						// player's inventory, first check to see if there's room for it.  If so,
						// then we'll give it to him normally.  If there's *NO* room, then we 
						// want to give the player the AMMO only (as if the player already had 
						// the weapon).

						if ((W != None) || ((W == None) && (!player.FindInventorySlot(item, True))))
						{
							// Don't bother with this is there's no ammo
							if ((Weapon(item).AmmoType != None) && (Weapon(item).AmmoType.AmmoAmount > 0))
							{
								AmmoType = Ammo(player.FindInventoryType(Weapon(item).AmmoName));

                        if ((AmmoType != None) && (AmmoType.AmmoAmount < AmmoType.MaxAmmo))
								{
                           AmmoType.AddAmmo(Weapon(item).PickupAmmoCount);
                           AddReceivedItem(player, AmmoType, Weapon(item).PickupAmmoCount);
                           
									// Update the ammo display on the object belt
									player.UpdateAmmoBeltText(AmmoType);

									// if this is an illegal ammo type, use the weapon name to print the message
									if (AmmoType.PickupViewMesh == Mesh'TestBox')
										P.ClientMessage(item.PickupMessage @ item.itemArticle @ item.itemName, 'Pickup');
									else
										P.ClientMessage(AmmoType.PickupMessage @ AmmoType.itemArticle @ AmmoType.itemName, 'Pickup');

									// Mark it as 0 to prevent it from being added twice
									Weapon(item).AmmoType.AmmoAmount = 0;
								}
							}

							// Print a message "Cannot pickup blah blah blah" if inventory is full
							// and the player can't pickup this weapon, so the player at least knows
							// if he empties some inventory he can get something potentially cooler
							// than he already has. 
							if ((W == None) && (!player.FindInventorySlot(item, True)))
								P.ClientMessage(Sprintf(Player.InventoryFull, item.itemName));

							// Only destroy the weapon if the player already has it.
							if (W != None)
							{
								// Destroy the weapon, baby!
								DeleteInventory(item);
								item.Destroy();
								item = None;
							}

							bPickedItemUp = True;
						}
					}

					else if (item.IsA('DeusExAmmo'))
					{
						if (DeusExAmmo(item).AmmoAmount == 0)
							bPickedItemUp = True;
					}

					if (!bPickedItemUp)
					{
						// Special case if this is a DeusExPickup(), it can have multiple copies
						// and the player already has it.

						if ((item.IsA('DeusExPickup')) && (DeusExPickup(item).bCanHaveMultipleCopies) && (player.FindInventoryType(item.class) != None))
						{
							invItem   = DeusExPickup(player.FindInventoryType(item.class));
							itemCount = DeusExPickup(item).numCopies;

							// Make sure the player doesn't have too many copies
							if ((invItem.MaxCopies > 0) && (DeusExPickup(item).numCopies + invItem.numCopies > invItem.MaxCopies))
							{	
								// Give the player the max #
								if ((invItem.MaxCopies - invItem.numCopies) > 0)
								{
									itemCount = (invItem.MaxCopies - invItem.numCopies);
									DeusExPickup(item).numCopies -= itemCount;
									invItem.numCopies = invItem.MaxCopies;
									P.ClientMessage(invItem.PickupMessage @ invItem.itemArticle @ invItem.itemName, 'Pickup');
									AddReceivedItem(player, invItem, itemCount);
								}
								else
								{
									P.ClientMessage(Sprintf(msgCannotPickup, invItem.itemName));
								}
							}
							else
							{
								invItem.numCopies += itemCount;
								DeleteInventory(item);

								P.ClientMessage(invItem.PickupMessage @ invItem.itemArticle @ invItem.itemName, 'Pickup');
								AddReceivedItem(player, invItem, itemCount);
							}
						}
						else
						{
							// check if the pawn is allowed to pick this up
							if ((P.Inventory == None) || (Level.Game.PickupQuery(P, item)))
							{
								DeusExPlayer(P).FrobTarget = item;
								if (DeusExPlayer(P).HandleItemPickup(Item) != False)
								{
                           DeleteInventory(item);

                           // DEUS_EX AMSD Belt info isn't always getting cleaned up.  Clean it up.
                           item.bInObjectBelt=False;
                           item.BeltPos=-1;
									
                           item.SpawnCopy(P);

									// Show the item received in the ReceivedItems window and also 
									// display a line in the Log
									AddReceivedItem(player, item, 1);
									
									P.ClientMessage(Item.PickupMessage @ Item.itemArticle @ Item.itemName, 'Pickup');
									PlaySound(Item.PickupSound);
								}
							}
							else
							{
								DeleteInventory(item);
								item.Destroy();
								item = None;
							}
						}
					}
				}

				item = nextItem;
			}
			until ((item == None) || (item == startItem));
		}

		//log("  bFoundSomething = " $ bFoundSomething);

		if (!bFoundSomething)
			P.ClientMessage(msgEmpty);
	}

	Super(Carcass).Frob(Frobber, frobWith);

	bQueuedDestroy = false;
}


// ----------------------------------------------------------------------
// AddReceivedItem()
// ----------------------------------------------------------------------

function AddReceivedItem(DeusExPlayer player, Inventory item, int count)
{
	local DeusExWeapon w;
	local Inventory altAmmo;

	if (!bSearchMsgPrinted)
	{
		player.ClientMessage(msgSearching);
		bSearchMsgPrinted = True;
	}

   DeusExRootWindow(player.rootWindow).hud.receivedItems.AddItem(item, 1);

	// Make sure the object belt is updated
	if (item.IsA('Ammo'))
		player.UpdateAmmoBeltText(Ammo(item));
	else
		player.UpdateBeltText(item);

}


// ----------------------------------------------------------------------
// auto state Dead
// ----------------------------------------------------------------------

auto state Dead
{
	function Timer()
	{
		Global.Timer();
	}

	function HandleLanding()
	{
		local Vector HitLocation, HitNormal, EndTrace;
		local Actor hit;
		local BloodPool pool;

		if (!bNotDead)
		{
			// trace down about 20 feet if we're not in water
			if (!Region.Zone.bWaterZone)
			{
				EndTrace = Location - vect(0,0,320);
				hit = Trace(HitLocation, HitNormal, EndTrace, Location, False);
            if ((DeusExMPGame(Level.Game) != None) && (!DeusExMPGame(Level.Game).bSpawnEffects))
            {
               pool = None;
            }
            else
            {
               pool = spawn(class'BloodPool',,, HitLocation+HitNormal, Rotator(HitNormal));
            }
				if (pool != None)
					pool.maxDrawScale = CollisionRadius / 40.0;
			}

			// alert NPCs that I'm food
			AIStartEvent('Food', EAITYPE_Visual);
		}

		// by default, the collision radius is small so there won't be as
		// many problems spawning carcii
		// expand the collision radius back to where it's supposed to be
		// don't change animal carcass collisions
		if (!bAnimalCarcass)
			SetCollisionSize(40.0, SavedCollisionHeight);

		// alert NPCs that I'm really disgusting
		if (bEmitCarcass)
			AIStartEvent('Carcass', EAITYPE_Visual);
	}

Begin:
	while (Physics == PHYS_Falling)
	{
		Sleep(1.0);
	}
	HandleLanding();

}


// ----------------------------------------------------------------------
// ----------------------------------------------------------------------

defaultproperties
{
	lifespan=0.000000
}
