//=============================================================================
// HXKeypad.
//=============================================================================
class HXKeypad extends Keypad
	abstract;



// ----------------------------------------------------------------------
// HackAction()
// ----------------------------------------------------------------------

function HackAction(Actor Hacker, bool bHacked)
{
	local DeusExPlayer Player;

	// if we're already using this keypad, get out
	if (keypadwindow != None)
		return;

	Player = DeusExPlayer(Hacker);

	if (Player != None)
	{
		// DEUS_EX AMSD if we are in multiplayer, just act based on bHacked
		// if you want keypad windows to work in multiplayer, just get rid of this
		// if statement.  I've already got the windows working, they're just disabled.
		//if (Level.NetMode != NM_Standalone)
		//{
		if (bHacked)
		{
			//ToggleLocks(Player);
			RunEvents(Player,True);
			RunUntriggers(Player);
		}
		//return;
		//}

		//DEUS_EX AMSD Must call in player for replication to work.
		Player.ActivateKeypadWindow(Self, bHacked);
	}
}


//
// Called to deal with resetting the device
// (moved here from HXHackableDevices)
//
function Tick(float deltaTime)
{
	 // reset stuff removed
   Super(ElectronicDevices).Tick(deltaTime);
}

//
// The main logic function for control panels
// (moved here from HXHackableDevices)
//
function Frob(Actor Frobber, Inventory frobWith)
{
	local Pawn P;
	local DeusExPlayer Player;
	local bool bHackIt, bDone;
	local string msg;
	local Vector X, Y, Z;
	local float dotp;

	P = Pawn(Frobber);
	Player = DeusExPlayer(P);
	bHackIt = False;
	bDone = False;
	msg = msgNotHacked;

	// make sure someone is trying to hack the device
	if (P == None)
		return;

	// Let any non-player pawn hack the device for now
	if (Player == None)
	{
		bHackIt = True;
		msg = "";
		bDone = True;
	}

	// If we are already trying to hack it, print a message
	if (bHacking)
	{
		msg = msgHacking;
		bDone = True;
	}

	if (!bDone)
	{
		// Get what's in the player's hand
		if (frobWith != None)
		{
			// check for the use of multitools
			if (bHackable && frobWith.IsA('Multitool') && (Player.SkillSystem != None))
			{
				if (hackStrength > 0.0)
				{
					// alert NPCs that I'm messing with stuff
					AIStartEvent('MegaFutz', EAITYPE_Visual);

					hackValue = Player.SkillSystem.GetSkillLevelValue(class'SkillTech');
					hackPlayer = Player;
					curTool = Multitool(frobWith);
					curTool.bBeingUsed = True;
					curTool.PlayUseAnim();
					bHacking = True;
					//Number of percentage points to remove
					numHacks = hackValue * 100;
					TicksPerHack = (hackTime * 10.0) / numHacks;
					LastTickTime = Level.TimeSeconds;
					TicksSinceLastHack = 0;
					SetTimer(0.1, True);
					msg = msgHacking;
				}
				else
				{
					bHackIt = True;
					msg = msgAlreadyHacked;
				}
			}
		}
		else if (hackStrength == 0.0)
		{
			// if it's open
			bHackIt = True;
			msg = "";
		}
	}

	// give the player a message
	if ((Player != None) && (msg != ""))
		Player.ClientMessage(msg);

	// if our hands are empty, call HackAction()
	if ((Player != None) && (frobWith == None))
		HackAction(Frobber, (hackStrength == 0.0));

	// trigger the device!
	if (bHackIt)
		Super(ElectronicDevices).Frob(Frobber, frobWith);
}



// ----------------------------------------------------------------------
// ----------------------------------------------------------------------

defaultproperties
{
}
